'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OptionMerger = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _variables = require('../conf/variables');

var VARS = _interopRequireWildcard(_variables);

var _utils = require('./utils');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Inheritance = (0, _utils.buildInheritance)(VARS);

var OptionMerger = exports.OptionMerger = function (_Inheritance) {
  _inherits(OptionMerger, _Inheritance);

  function OptionMerger() {
    _classCallCheck(this, OptionMerger);

    var _this = _possibleConstructorReturn(this, (OptionMerger.__proto__ || Object.getPrototypeOf(OptionMerger)).call(this));

    _this.file = _this.findRC();
    return _this;
  }

  _createClass(OptionMerger, [{
    key: 'readRC',
    value: function readRC() {
      var file = this.file;
      return file ? _fsExtra2.default.readJSONSync(file) : {};
    }
  }, {
    key: 'updateRC',
    value: function updateRC(source) {
      var file = this.file;
      if (!file) {
        return false;
      }

      var originSource = _fsExtra2.default.readJSONSync(file);
      source = _lodash2.default.defaultsDeep(source, originSource);

      _fsExtra2.default.writeFileSync(file, JSON.stringify(source, null, 2));
    }
  }, {
    key: 'findRC',
    value: function findRC() {
      var file = _path2.default.join(VARS.ROOT_PATH, VARS.RC_FILE || '.ngwprc');
      if (_fsExtra2.default.existsSync(file)) {
        return file;
      }

      return null;
    }
  }]);

  return OptionMerger;
}(Inheritance);

exports.default = new OptionMerger();