'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.run = run;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function run(file, options) {
  if (!_fsExtra2.default.existsSync(file)) {
    throw new Error('Config file ' + file + ' is not exists.');
  }

  var config = require(file).default;
  var compiler = (0, _webpack2.default)(config);

  options = _lodash2.default.defaultsDeep(options, {
    watch: false
  });

  if (true === options.watch) {
    compiler.watch({
      aggregateTimeout: 300,
      poll: true
    }, function (error, stats) {
      if (error) {
        throw error;
      }

      printStats(stats);
    });
  } else {
    compiler.run(function (error, stats) {
      if (error) {
        throw error;
      }

      printStats(stats);
    });
  }
}

function printStats(stats) {
  /* eslint no-console:off */
  var message = stats.toString({
    chunks: false,
    colors: true
  });

  console.log(message);
}